;Copyright (C) 1997-2001 ZSNES Team ( zsknight@zsnes.com / _demo_@zsnes.com )
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later
;version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

%include "macros.mac"

EXTSYM BRRPlace0,BRRPlace1,BRRPlace2,BRRPlace3,BRRPlace4,BRRPlace5,BRRPlace6
EXTSYM BRRPlace7,Decrease,DecreaseRateExp,EchoFB,EchoRate,EchoVL,EchoVR
EXTSYM FIRTAPVal0,FIRTAPVal1,FIRTAPVal2,FIRTAPVal3,FIRTAPVal4,FIRTAPVal5
EXTSYM FIRTAPVal6,FIRTAPVal7,GlobalVL,GlobalVR,Increase,IncreaseBent
EXTSYM MaxEcho,NoiseInc,NoiseSpeeds,SBToSPC,Voice0End,Voice0EnvInc
EXTSYM Voice0IncNumber,Voice0Loop,Voice0Noise,Voice0Prev0,Voice0Prev1
EXTSYM Voice0Start,Voice0State,Voice0Status,Voice0Time,Voice1End,Voice1Noise
EXTSYM Voice1Prev0,Voice1Prev1,Voice1Start,Voice2End,Voice2Noise,Voice2Prev0
EXTSYM Voice2Prev1,Voice2Start,Voice3End,Voice3Noise,Voice3Prev0,Voice3Prev1
EXTSYM Voice3Start,Voice4End,Voice4Noise,Voice4Prev0,Voice4Prev1,Voice4Start
EXTSYM Voice5End,Voice5Noise,Voice5Prev0,Voice5Prev1,Voice5Start,Voice6End
EXTSYM Voice6Noise,Voice6Prev0,Voice6Prev1,Voice6Start,Voice7End,Voice7Noise
EXTSYM Voice7Prev0,Voice7Prev1,Voice7Start,VolumeConvTable,VolumeTableb
EXTSYM RevStereo,Voice1Status,Voice2Status,Voice3Status,Voice4Status,Voice5Status
EXTSYM Voice6Status,Voice7Status
EXTSYM GainDecBendDataPos,GainDecBendDataTime,GainDecBendDataDat
EXTSYM AdsrSustLevLoc,AdsrBlocksLeft,AdsrNextTimeDepth
EXTSYM MuteVoiceF,VoiceStarter
EXTSYM DecayRate,SustainRate,SustainValue

SECTION .bss
NEWSYM KeyOnStA, resb 1
NEWSYM KeyOnStB, resb 1


%define _musicvol 127

SECTION .data

; Digital Sound Processor of the SPC700 By _Demo_

SECTION .bss ;ALIGN=32
NEWSYM DSPMem, resb 128;256
SECTION .code

%macro ProcessGain 1
      push eax
      push ebx
      push edx
      test byte [DSPMem+07h+%1*10h],80h
      jz near %%Direct
      test byte [DSPMem+07h+%1*10h],40h
      jnz near %%Increase
      test byte [DSPMem+07h+%1*10h],20h
      jz near %%LinearDec
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[DecreaseRateExp+eax*4]
      mov dword[Voice0EnvInc+%1*4],007FFFFFh
      shr ebx,5
      mov dword[Voice0Time+%1*4],ebx
      mov [GainDecBendDataTime+%1*4],ebx
      xor edx,edx
      mov eax,127*65536
      sub eax,118*65536
      mov byte[GainDecBendDataPos+%1],0
      mov byte[GainDecBendDataDat+%1],127
      div ebx
      neg eax
      mov dword [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],7
      ret
ALIGN4
%%LinearDec
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Decrease+eax*4]
      mov dword[Voice0EnvInc+%1*4],007FFFFFh
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      mov eax,127*65536
      div ebx
      neg eax
      mov dword [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],5
      ret
ALIGN4
%%Increase
      test byte [DSPMem+07h+%1*10h],20h
      jz %%LinearInc
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Increase+eax*4]
      mov dword[Voice0EnvInc+%1*4],0
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      mov eax,127*65536
      div ebx
      mov dword [Voice0IncNumber+%1*4],eax
      mov ebx,[Voice0Time+%1*4]
      mov eax,ebx
      shr eax,2
      sub ebx,eax
      dec ebx
      mov [Voice0Time+%1*4],ebx
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],6
      ret
ALIGN4
%%LinearInc
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Increase+eax*4]
      mov dword[Voice0EnvInc+%1*4],0
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      mov eax,127*65536
      div ebx
      mov dword [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],3
      ret
ALIGN4
%%Direct
      mov al,[DSPMem+07h+%1*10h]
      and al,7Fh
      mov dword[Voice0EnvInc+%1*4],0
      mov byte [Voice0EnvInc+%1*4+2],al
      mov dword [Voice0Time+%1*4],0FFFFFFFFh
      mov dword [Voice0IncNumber+%1*4],0
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],4
      ret
%endmacro

%macro ProcessGain2 1
      push eax
      push ebx
      push edx
      test byte [DSPMem+07h+%1*10h],80h
      jz near %%Direct
      test byte [DSPMem+07h+%1*10h],40h
      jnz near %%Increase
      test byte [DSPMem+07h+%1*10h],20h
      jz near %%LinearDec
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[DecreaseRateExp+eax*4]
      shr ebx,5
      mov dword[Voice0Time+%1*4],ebx
      mov [GainDecBendDataTime+%1*4],ebx
      xor edx,edx
      mov dh,118
      mov dl,[Voice0EnvInc+%1*4+2]
      xor eax,eax
      mov al,[VolumeConvTable+edx*2]
      xor edx,edx
      shl eax,16
      mov dl,[Voice0EnvInc+%1*4+2]
      neg eax
      shl edx,16
      add eax,edx
      xor edx,edx
      mov byte[GainDecBendDataPos+%1],0
      div ebx
      neg eax
      mov [Voice0IncNumber+%1*4],eax
      mov al,[Voice0EnvInc+%1*4+2]
      mov [GainDecBendDataDat+%1],al
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],7
      ret
ALIGN4
%%LinearDec
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Decrease+eax*4]
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      xor eax,eax
      mov al,[Voice0EnvInc+%1*4+2]
      shl eax,16
      div ebx
      neg eax
      mov dword [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],5
      ret
ALIGN4
%%Increase
      test byte [DSPMem+07h+%1*10h],20h
      jz %%LinearInc
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Increase+eax*4]
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      xor eax,eax
      mov al,[Voice0EnvInc+%1*4+2]
      inc al
      test al,80h
      jz %%noof
      mov al,127
%%noof
      xor al,127
      shl eax,16
      div ebx
      mov dword [Voice0IncNumber+%1*4],eax
      mov ebx,[Voice0Time+%1*4]
      mov eax,ebx
      shr eax,2
      sub ebx,eax
      dec ebx
      mov [Voice0Time+%1*4],ebx
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],6
      ret
ALIGN4
%%LinearInc
      xor eax,eax
      mov al,[DSPMem+07h+%1*10h]
      and al,1Fh
      mov ebx,[Increase+eax*4]
      mov dword[Voice0Time+%1*4],ebx
      xor edx,edx
      xor eax,eax
      mov al,[Voice0EnvInc+%1*4+2]
      inc al
      test al,80h
      jz %%noof2
      mov al,127
%%noof2
      xor al,127
      shl eax,16
      div ebx
      mov dword [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],3
      ret
ALIGN4
%%Direct
      mov al,[DSPMem+07h+%1*10h]
      and al,7Fh
      mov dword[Voice0EnvInc+%1*4],0
      mov byte [Voice0EnvInc+%1*4+2],al
      mov dword [Voice0Time+%1*4],0FFFFFFFFh
      mov dword [Voice0IncNumber+%1*4],0
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],4
      ret
ALIGN4
%%end
      pop edx
      pop ebx
      pop eax
      ret
%endmacro


%macro SwitchSustain 1
      push eax
      push ebx
      push edx
      mov al,[Voice0EnvInc+%1*4+2]
      mov [GainDecBendDataDat+%1],al
      cmp byte[Voice0State+%1],8
      je %%full
      cmp byte[Voice0State+%1],2
      jae %%nofull
%%full
      mov byte[GainDecBendDataDat+%1],7Fh
%%nofull
      mov al,[DSPMem+05h+%1*10h]
      shr al,4
      and eax,07h
      mov edx,[DecayRate+eax*4]
      xor eax,eax
      mov al,[DSPMem+06h+%1*10h]
      and al,1Fh
      mov ebx,[SustainRate+eax*4]
      cmp edx,ebx
      jae near %%decayover
      ; ebx = total sustain time
      xor eax,eax
      mov al,[DSPMem+06h+%1*10h]
      shr al,5
      mov al,[AdsrSustLevLoc+eax]
      ; traverse through al entries in edx time
      ; then through 64-al entries in ebx-edx time
      mov [AdsrBlocksLeft+%1],al
      sub ebx,edx
      push ebx
      push eax
      mov ebx,eax
      mov eax,edx
      xor edx,edx
      or ebx,ebx
      jz .oopszero
      div ebx
.oopszero
      mov [Voice0Time+%1*4],eax
      mov [GainDecBendDataTime+%1*4],eax
      pop eax
      pop ebx
      mov edx,ebx
      mov ebx,64
      sub bl,al
      mov eax,edx
      xor edx,edx
      div ebx
      mov [AdsrNextTimeDepth+%1*4],eax
      mov dword[Voice0EnvInc+%1*4],0
      mov al,[GainDecBendDataDat+%1]
      mov [Voice0EnvInc+%1*4+2],al
      mov ebx,[Voice0Time+%1*4]
      xor edx,edx

      mov dh,122
      mov dl,[Voice0EnvInc+%1*4+2]
      xor eax,eax
      mov al,[VolumeConvTable+edx*2]
      xor edx,edx
      shl eax,16
      mov dl,[Voice0EnvInc+%1*4+2]
      neg eax
      shl edx,16
      add eax,edx
      xor edx,edx
      mov byte[GainDecBendDataPos+%1],0
      div ebx
      neg eax
      mov [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],9
      ret
ALIGN4
%%decayover
      sub edx,ebx
      push ebx
      mov eax,edx
      xor ebx,ebx
      mov bl,[DSPMem+06h+%1*10h]
      shr bl,5
      xor bl,07h
      mul ebx
      mov ebx,7
      div ebx
      pop ebx
      add ebx,eax
      mov dword[Voice0EnvInc+%1*4],007FFFFFh
      shr ebx,5
      mov dword[Voice0Time+%1*4],ebx
      mov [GainDecBendDataTime+%1*4],ebx
      xor edx,edx

      mov dh,118
      mov dl,[Voice0EnvInc+%1*4+2]
      xor eax,eax
      mov al,[VolumeConvTable+edx*2]
      xor edx,edx
      shl eax,16
      mov dl,[Voice0EnvInc+%1*4+2]
      neg eax
      shl edx,16
      add eax,edx
      xor edx,edx
      mov byte[GainDecBendDataPos+%1],0
      div ebx
      neg eax
      mov [Voice0IncNumber+%1*4],eax
      pop edx
      pop ebx
      pop eax
      mov byte [Voice0State+%1],7
      ret
%endmacro

%macro VoiceAdsr 1
      test byte[MuteVoiceF],1 << %1
      jnz near .nogain
      cmp byte[Voice0State+%1],200
      je near .nogain
      cmp [DSPMem+05h+%1*10h],al
      je near .nogain
      test al,80h
      jz near .gain
      mov [DSPMem+05h+%1*10h],al
      SwitchSustain %1
      ret
ALIGN4
.nogain
      mov [DSPMem+05h+%1*10h],al
      ret
ALIGN4
.gain
      cmp byte[Voice0Status+%1],1
      jne .nogain
      cmp word[DSPMem+06h+%1*10h],0A0E0h
      je .nogain
      test byte[DSPMem+05h+%1*10h],80h
      jz near .gain2
      cmp byte[Voice0State+%1],8
      je .gain1
      cmp byte[Voice0State+%1],2
      jae near .gain2
.gain1
      mov [DSPMem+05h+%1*10h],al
      ProcessGain %1   ; Normal
      ret
ALIGN4
.gain2
      mov [DSPMem+05h+%1*10h],al
      cmp byte [Voice0State+%1],210
      jne %%noendofsamp2
      push eax
      push ebx
      mov al,%1
      call VoiceStarter
      mov dword[Voice0EnvInc+%1*4],007FFFFFh
      pop ebx
      pop eax
%%noendofsamp2
      ProcessGain2 %1
      ret
%endmacro

%macro VoiceAdsr2 1
      test byte[MuteVoiceF],1 << %1
      jnz near .noadsrswitch
      cmp byte[Voice0State+%1],200
      je near .noadsrswitch
      cmp [DSPMem+06h+%1*10h],al
      je near .noadsrswitch
      mov [DSPMem+06h+%1*10h],al
      test byte[DSPMem+05h+%1*10h],80h
      jz near .noadsrswitch
      SwitchSustain %1
      ret
ALIGN4
.noadsrswitch
      mov [DSPMem+06h+%1*10h],al
      ret
%endmacro


%macro VoiceGain 1
      test byte[MuteVoiceF],1 << %1
      jnz near .nogain
      cmp byte[Voice0State+%1],200
      je near .nogain
      cmp [DSPMem+07h+%1*10h],al
      je near .nogain
      mov [DSPMem+07h+%1*10h],al
      cmp byte[Voice0Status+%1],1
      jne .nogain
      test byte[DSPMem+05h+%1*10h],80h
      jz .gain
.nogain
      mov [DSPMem+07h+%1*10h],al
      ret
ALIGN4
.gain
      cmp byte [Voice0State+%1],210
      jne %%noendofsamp
      push eax
      push ebx
      mov al,%1
      call VoiceStarter
      pop ebx
      pop eax
%%noendofsamp
      ProcessGain2 %1
%endmacro

SECTION .bss
NEWSYM ADSRGAINSwitch, resb 1
SECTION .data

;Write DSP Registers functions


SECTION .bss
NEWSYM TempValueSnd, resb 1
SECTION .data

ALIGN4
NEWSYM WDSPReg05       ; Voice  0  ADSR (1)
      inc byte[TempValueSnd]
      VoiceAdsr 0
      ret

ALIGN4
NEWSYM WDSPReg06       ; Voice  0  ADSR (2)                                                                                                                                                                                                                                                        
      inc byte[TempValueSnd]
      VoiceAdsr2 0
      ret

ALIGN4
NEWSYM WDSPReg07       ; Voice  0  GAIN                                                                                                                                                                                                                                                            
      inc byte[TempValueSnd]
      VoiceGain 0
      ret


ALIGN4
NEWSYM WDSPReg0C       ; Voice  0                                                                                                                                                                                                                                                                  
      mov [DSPMem+0Ch],al
      push eax
      and eax,0FFh
      mov al,[VolumeTableb+eax]
      mov ah,_musicvol
      mov al,[VolumeConvTable+eax*2]
;      cmp byte[RevStereo],1
;      je .rev
      mov [GlobalVL],al
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg0D       ; Echo Feedback                                                                                                                                                                                                                                                             
      mov [DSPMem+0Dh],al
      push eax
      and eax,0FFh
      mov al,[VolumeTableb+eax]
      mov [EchoFB],eax
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg0F       ; Voice  0  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+0Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal0],eax
      pop eax
      ret


ALIGN4
NEWSYM WDSPReg15       ; Voice  1  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 1
      ret

ALIGN4
NEWSYM WDSPReg16       ; Voice  1  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 1
      ret

ALIGN4
NEWSYM WDSPReg17       ; Voice  1  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 1
      ret

ALIGN4
NEWSYM WDSPReg1C       ; Voice  1                                                                                                                                                                                                                                                                  
      mov [DSPMem+01Ch],al
      push eax
      and eax,0FFh
      mov al,[VolumeTableb+eax]
      mov ah,_musicvol
      mov al,[VolumeConvTable+eax*2]
;      cmp byte[RevStereo],1
;      je .rev
      mov [GlobalVR],al
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg1F       ; Voice  1  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+01Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal1],eax
      pop eax
      ret


ALIGN4
NEWSYM WDSPReg25       ; Voice  2  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 2
      ret

ALIGN4
NEWSYM WDSPReg26       ; Voice  2  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 2
      ret

ALIGN4
NEWSYM WDSPReg27       ; Voice  2  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 2
      ret


ALIGN4
NEWSYM WDSPReg2C       ; Voice  2                                                                                                                                                                                                                                                                  
      mov [DSPMem+02Ch],al
      push eax
      and eax,0FFh
      mov al,[VolumeTableb+eax]
      mov ah,_musicvol
      mov al,[VolumeConvTable+eax*2]
;      cmp byte[RevStereo],1
;      je .rev
      mov [EchoVL],al
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg2F       ; Voice  2  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+02Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal2],eax
      pop eax
      ret


ALIGN4
NEWSYM WDSPReg35       ; Voice  3  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 3
      ret

ALIGN4
NEWSYM WDSPReg36       ; Voice  3  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 3
      ret

ALIGN4
NEWSYM WDSPReg37       ; Voice  3  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 3
      ret

ALIGN4
NEWSYM WDSPReg3C       ; Voice  3                                                                                                                                                                                                                                                                  
      mov [DSPMem+03Ch],al
      push eax
      and eax,0FFh
      mov al,[VolumeTableb+eax]
      mov ah,_musicvol
      mov al,[VolumeConvTable+eax*2]
;      cmp byte[RevStereo],1
;      je .rev
      mov [EchoVR],al
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg3D       ; Voice  3                                                                                                                                                                                                                                                                  
      mov byte [Voice0Noise],0
      mov byte [Voice1Noise],0
      mov byte [Voice2Noise],0
      mov byte [Voice3Noise],0
      mov byte [Voice4Noise],0
      mov byte [Voice5Noise],0
      mov byte [Voice6Noise],0
      mov byte [Voice7Noise],0
      test al,1
      jz .TestVoice1
      mov byte [Voice0Noise],1
.TestVoice1
      test al,2
      jz .TestVoice2
      mov byte [Voice1Noise],1
.TestVoice2
      test al,4
      jz .TestVoice3
      mov byte [Voice2Noise],1
.TestVoice3
      test al,8
      jz .TestVoice4
      mov byte [Voice3Noise],1
.TestVoice4
      test al,16
      jz .TestVoice5
      mov byte [Voice4Noise],1
.TestVoice5
      test al,32
      jz .TestVoice6
      mov byte [Voice5Noise],1
.TestVoice6
      test al,64
      jz .TestVoice7
      mov byte [Voice6Noise],1
.TestVoice7
      test al,128
      jz .TestVoice8
      mov byte [Voice7Noise],1
.TestVoice8
      mov [DSPMem+03Dh],al
      ret


ALIGN4
NEWSYM WDSPReg3F       ; Voice  3  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+03Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal3],eax
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg45       ; Voice  4  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 4
      ret

ALIGN4
NEWSYM WDSPReg46       ; Voice  4  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 4
      ret

ALIGN4
NEWSYM WDSPReg47       ; Voice  4  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 4
      ret

ALIGN4
NEWSYM WDSPReg4C       ; Key On
      push ebx
      mov bl,[MuteVoiceF]
      xor bl,0FFh
      and bl,al
      or byte[KeyOnStA],bl
      pop ebx
      test al,80h
      jz .nokon
;      inc byte[SoundTest]
.nokon
      mov [DSPMem+04Ch],al
      push eax
      xor al,0FFh
      and byte [DSPMem+07Ch],al
      pop eax
      ret

NEWSYM ProcessKeyOn
      test al,1
      jz .TestVoice1
      push edx
      call Voice0Start
      pop edx
.TestVoice1
      test al,2
      jz .TestVoice2
      push edx
      call Voice1Start
      pop edx
.TestVoice2
      test al,4
      jz .TestVoice3
      push edx
      call Voice2Start
      pop edx
.TestVoice3
      test al,8
      jz .TestVoice4
      push edx
      call Voice3Start
      pop edx
.TestVoice4
      test al,16
      jz .TestVoice5
      push edx
      call Voice4Start
      pop edx
.TestVoice5
      test al,32
      jz .TestVoice6
      push edx
      call Voice5Start
      pop edx
.TestVoice6
      test al,64
      jz .TestVoice7
      push edx
      call Voice6Start
      pop edx
.TestVoice7
      test al,128
      jz .TestVoice8
      push edx
      call Voice7Start
      pop edx
.TestVoice8
      test al,0FFh
      jz .novoice
;      mov byte[keyonsn],1
.novoice
      ret

ALIGN4
NEWSYM WDSPReg4F       ; Voice  4  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+04Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal4],eax
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg55       ; Voice  5  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 5
      ret

ALIGN4
NEWSYM WDSPReg56       ; Voice  5  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 5
      ret

ALIGN4
NEWSYM WDSPReg57       ; Voice  5  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 5
      ret

%macro keyoffm 1
    test byte[MuteVoiceF],1 << %1
    jnz %%nokeyoff
    push eax
    push edx
    push ebx
    mov dword[Voice0Time+%1*4],255
    mov eax,[Voice0EnvInc+%1*4]
    shr eax,8
    neg eax
    mov dword[Voice0IncNumber+%1*4],eax
    mov byte [Voice0State+%1],200
    mov byte [DSPMem+08h+%1*10h],0
    or byte [DSPMem+7Ch],1 << %1
    pop ebx
    pop edx
    pop eax
%%nokeyoff
%endmacro

ALIGN4
NEWSYM WDSPReg5C       ; Key Off
      push eax
      xor al,0FFh
      and byte[KeyOnStA],al
      and byte[KeyOnStB],al
      pop eax
      test al,1
      jz .TestVoice1
      keyoffm 0
.TestVoice1
      test al,2
      jz .TestVoice2
      keyoffm 1
.TestVoice2
      test al,4
      jz .TestVoice3
      keyoffm 2
.TestVoice3
      test al,8
      jz .TestVoice4
      keyoffm 3
.TestVoice4
      test al,16
      jz .TestVoice5
      keyoffm 4
.TestVoice5
      test al,32
      jz .TestVoice6
      keyoffm 5
.TestVoice6
      test al,64
      jz .TestVoice7
      keyoffm 6
.TestVoice7
      test al,128
      jz .TestVoice8
      keyoffm 7
.TestVoice8
      mov [DSPMem+05Ch],al
      ret

ALIGN4
NEWSYM WDSPReg5F       ; Voice  5  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+05Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal5],eax
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg65       ; Voice  6  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 6
      ret

ALIGN4
NEWSYM WDSPReg66       ; Voice  6  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 6
      ret

ALIGN4
NEWSYM WDSPReg67       ; Voice  6  GAIN                                                                                                                                                                                                                                                            
      VoiceGain 6
      ret


SECTION .bss
spcres resb 1
SECTION .code

ALIGN4
NEWSYM WDSPReg6C       ; Voice  6
      mov [DSPMem+06Ch],al
      and byte [DSPMem+06Ch],7Fh
      test al,128
      jz .NoRes
      inc byte[spcres]
.NoRes
      test al,0C0h
      jz .NoRes2
      mov byte[Voice0Status],0
      mov byte[Voice1Status],0
      mov byte[Voice2Status],0
      mov byte[Voice3Status],0
      mov byte[Voice4Status],0
      mov byte[Voice5Status],0
      mov byte[Voice6Status],0
      mov byte[Voice7Status],0
.NoRes2
      push eax
      push ebx
      push ecx
      push edx
      and eax,1Fh
      xor edx,edx
      mov eax,[NoiseSpeeds+eax*4]
      mov ebx,[SBToSPC]
      shl eax,16
      div ebx
      shl eax,2
      mov [NoiseInc],eax
      pop edx
      pop ecx
      pop ebx
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg6F       ; Voice  6  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+06Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal6],eax
      pop eax
      ret

ALIGN4
NEWSYM WDSPReg75       ; Voice  7  ADSR (1)                                                                                                                                                                                                                                                        
      VoiceAdsr 7
      ret

ALIGN4
NEWSYM WDSPReg76       ; Voice  7  ADSR (2)                                                                                                                                                                                                                                                        
      VoiceAdsr2 7
      ret

ALIGN4
NEWSYM WDSPReg77       ; Voice  7  GAIN
      VoiceGain 7
      ret

ALIGN4
NEWSYM WDSPReg7C       ; ENDX
      mov byte [DSPMem+07Ch],0
      ret

ALIGN4
NEWSYM WDSPReg7D       ; Echo Delay                                                                                                                                                                                                                                                                
      mov [DSPMem+07Dh],al
      push ebx
      mov ebx,eax
      and ebx,0Fh
      mov ebx,[EchoRate+ebx*4]
      mov [MaxEcho],ebx
      pop ebx
      ret

ALIGN4
NEWSYM WDSPReg7F       ; Voice  7  Echo coefficient                                                                                                                                                                                                                                                
      mov [DSPMem+07Fh],al
      push eax
      movsx eax,al
      mov [FIRTAPVal7],eax
      pop eax
      ret

ALIGN16
NEWSYM WDSPRegXX
	mov [DSPMem+ebx],al
	ret
	
SECTION .data
ALIGN32
NEWSYM dspWptr
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg05,WDSPReg06,WDSPReg07
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg0C,WDSPReg0D,WDSPRegXX,WDSPReg0F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg15,WDSPReg16,WDSPReg17
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg1C,WDSPRegXX,WDSPRegXX,WDSPReg1F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg25,WDSPReg26,WDSPReg27
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg2C,WDSPRegXX,WDSPRegXX,WDSPReg2F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg35,WDSPReg36,WDSPReg37
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg3C,WDSPReg3D,WDSPRegXX,WDSPReg3F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg45,WDSPReg46,WDSPReg47
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg4C,WDSPRegXX,WDSPRegXX,WDSPReg4F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg55,WDSPReg56,WDSPReg57
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg5C,WDSPRegXX,WDSPRegXX,WDSPReg5F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg65,WDSPReg66,WDSPReg67
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg6C,WDSPRegXX,WDSPRegXX,WDSPReg6F
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg75,WDSPReg76,WDSPReg77
	dd WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPRegXX,WDSPReg7C,WDSPReg7D,WDSPRegXX,WDSPReg7F