;Copyright (C) 1997-2001 ZSNES Team ( zsknight@zsnes.com / _demo_@zsnes.com )
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later
;version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

%include "macros.mac"


EXTSYM KeyOnStA,KeyOnStB,ProcessKeyOn
EXTSYM spcPCRam

EXTSYM ResetState
EXTSYM spcRam,spcRamDP,spcA,spcY
EXTSYM initpitch
EXTSYM totlines


NEWSYM ExecuteAsmStart

EXTSYM cyclesperline



EXTSYM opcjmptab
EXTSYM timeron,timinl0,timincr0,timinl1,timincr1,timinl2,timincr2
EXTSYM halted,spcnumread

section .data
NEWSYM curcyc, dd 0
NEWSYM MuteVoiceF, db 0
curline dd 0

section .code

ALIGN16

NEWSYM StartSPC
	pushad
    xor ebx,ebx
	mov eax,[totlines]
	mov [curline],eax

    mov esi,[curcyc]             ; set cycles
    mov ebp,[spcPCRam]
	mov dl,[spcA]
	mov dh,[spcY]
    
    call execute

    mov [spcPCRam],ebp
    mov [curcyc],esi

	mov [spcA],dl
	mov [spcY],dh

	popad
	ret


ALIGN16

NEWSYM execute
	cmp dword[halted],0
	jne op_ret.halt
    mov bl,[ebp]
	mov edi, ebx
    inc ebp
    jmp dword near [opcjmptab+ebx*4]

ALIGN16
NEWSYM op_ret
	add esi,dword[cyclesperline]
.halt
    cmp byte[KeyOnStB],0
    je .nokeyon
    mov al,[KeyOnStB]
    call ProcessKeyOn
.nokeyon
    mov al,[KeyOnStA]
    mov [KeyOnStB],al
    mov byte[KeyOnStA],0

      test byte[timeron],1
      jz .noin0
      dec byte[timinl0]	;8khz
      jnz .noin0
      mov al,[timincr0]
	  inc byte[spcRam+0FDh]
		
	  	cmp byte[halted+0],0
		
		mov [timinl0],al
		jz .noin0
		mov dword[halted],0
		mov esi,dword[cyclesperline]
      
.noin0
      test byte[timeron],2
      jz .noin1
      dec byte[timinl1]	;8khz
      jnz .noin1
      mov al,[timincr1]
	  inc byte[spcRam+0FEh]
		
	  	cmp byte[halted+1],0
		mov [timinl1],al
		jz .noin1
		mov dword[halted],0
		mov esi,dword[cyclesperline]
.noin1
.notimer	;3rd timer, 64khz (8*8 hack)	i don't think anyone uses resolutions above 8khz (some games (eg. FF6, ToP) set high resolutions then totally ignore the timer)
      test byte[timeron],4
      jz near .noin2
      sub byte[timinl2],8
      jnc .noin2
      
	  	cmp byte[halted+2],0
		mov al,[timincr2]
		jz .in2a
		mov dword[halted],0
		mov esi,dword[cyclesperline]
.in2a
	  test al,al
	  jz .noin2
.in2
	  inc byte[spcRam+0FFh]
      add [timinl2],al
	  jnc .in2
.noin2

	dec dword[curline]
    jnz near execute
	ret


EXTSYM reset_shit

NEWSYM postSPCload
	pushad
	call reset_shit
 

    call initpitch

    add dword[spcPCRam],spcRam
    add dword[spcRamDP],spcRam
    call ResetState
	mov eax,dword[cyclesperline]
	mov dword[curcyc],eax
	popad
ret

NEWSYM ExecuteAsmEnd

