;Copyright (C) 1997-2001 ZSNES Team ( zsknight@zsnes.com / _demo_@zsnes.com )
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later
;version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

%include "macros.mac"
;STUB DDOI

NEWSYM InitAsmStart

SECTION .data

;NEWSYM MusicRelVol,   db 100
;NEWSYM MusicVol,      db 127

f_init db 0
NEWSYM hw_mmx,db 0

;mixfunc dd 0

EXTSYM downmix_32216,downmix_32216_mmx
;EXTSYM downmix_32216_s,downmix_32216_s_mmx

SECTION .code

EXTSYM downmix_func ;,downmix_func_s

SECTION .data
samplenoise
  db 27,232,234,138,187,246,176,81,25,241,1,127,154,190,195,103,231,165,220,238
  db 232,189,57,201,123,75,63,143,145,159,13,236,191,142,56,164,222,80,88,13
  db 148,118,162,212,157,146,176,0,241,88,244,238,51,235,149,50,77,212,186,241
  db 88,32,23,206,1,24,48,244,248,210,253,77,19,100,83,222,108,68,11,58
  db 152,161,223,245,4,105,3,82,15,130,171,242,141,2,172,218,152,97,223,157
  db 93,75,83,238,104,238,131,70,22,252,180,82,110,123,106,133,183,209,48,230
  db 157,205,27,21,107,63,85,164


ALIGN4
NEWSYM onetime_init
		mov al,1
		xchg [f_init],al
		test al,al
		je .init
		ret
.init
		pushad

    mov edi,NoiseData
    mov ebx,256
    mov ecx,128
    xor esi,esi
    xor edx,edx
.next
    mov al,[samplenoise+esi]
    add al,[samplenoise+edx]
    mov [edi],al
    inc edi
    inc esi
    and esi,07Fh
    dec edx
    and edx,07Fh
    dec ecx
    jnz .next
    dec edx
    and edx,07Fh
    mov ecx,128
    dec ebx
    jnz .next


      mov ecx,32768
      mov edx,32767
.nextvol
      mov al,dh
      imul dl
      shr ax,7
      movsx bx,al
      mov [VolumeConvTable+edx*2],bx
      dec edx
      dec ecx
      jnz .nextvol



		pushfd
		pop eax
		mov ebx,eax
		xor eax,0x00200000
		push eax
		popfd
		pushfd
		pop eax
		cmp eax,ebx
		jz .q
		xor eax,eax
		cpuid
		test eax,eax
		jz .q
		mov eax,0x00000001
		cpuid
		test edx,0x00800000
		setnz byte[hw_mmx]
.q
		cmp byte[hw_mmx],0
		je .nommx
		mov dword[downmix_func],downmix_32216_mmx
		;mov dword[downmix_func_s],downmix_32216_s_mmx
		jmp .q2
.nommx
		mov dword[downmix_func],downmix_32216
		;mov dword[downmix_func_s],downmix_32216_s
.q2
		popad
.r
		ret




NEWSYM muldiv
	mov eax,[esp+4]
	mul dword[esp+8]
	div dword[esp+12]
	ret

SECTION .bss


; init.asm
;EXTSYM echobuf,       resb 160000

; dspproc.asm

  resb ($$-$) & 1Fh	;ALIGN32


NEWSYM VolumeConvTable, resw 32768
NEWSYM NoiseData, resb 32768

NEWSYM spcBuffer, resb 65536*4+4096

