#ifdef __cplusplus
extern "C"
{
#endif

#pragma pack(push)
#pragma pack(1)
typedef struct
{
	BYTE RevStereo;
	BYTE SoundInterpType;
	BYTE LowPassFilter;
	BYTE Surround;
	BYTE SoundNoiseDis;
	BYTE NoSpeedHack;
	WORD Refresh;
	DWORD MixingFrequency;
	DWORD SpeedMultiplier;//dll version 4+ only; actual_speed = n*1024khz; default:2
} ZSNES_CONFIG;
#pragma pack(pop)


void zsnes_setconfig(ZSNES_CONFIG*);
void zsnes_setup(void * image);
UINT zsnes_doframe(void * out);
void zsnes_seek(void * image,UINT ms,char * kill);
UINT zsnes_dllversion();
BOOL zsnes_dllversion2(UINT v);
void zsnes_setmute(BYTE flags);

#ifdef __cplusplus
}
#endif
